مولّد TOTP (رموز المصادقة الثنائية)

ولّد كلمات مرور لمرة واحدة قائمة على الوقت (TOTP) من مفتاح Base32 بـ SHA-1/256/512 و6–8 أرقام وأي مدة. عدّ تنازلي حي ومتحقق من RFC 6238.

المفتاح الذي تعرضه الخدمة عند إعداد المصادقة الثنائية. المسافات والأحرف الصغيرة مقبولة.

اتركه فارغًا لاستخدام الوقت الحالي.

يحسب TOTP (RFC 6238) قيمة HOTP بالعدّاد T = floor(وقت Unix / المدة). تستخدم معظم التطبيقات SHA-1 و6 أرقام و30 ثانية. يجب أن تكون ساعة جهازك دقيقة. لا يغادر المفتاح متصفحك، لكن تعامل معه ككلمة مرور.

يعمل بالكامل في متصفحك. لا يتم رفع بياناتك أبدًا.

ما هو مولّد TOTP (المصادقة الثنائية)؟

تحسب هذه الأداة الرموز المكوّنة من 6–8 أرقام نفسها التي تعرضها تطبيقات المصادقة، من مفتاح سري بصيغة Base32. تتحدث مباشرة بعدّ تنازلي، وتعرض أيضًا الرمزين السابق والتالي، ويمكنها حساب الرمز لأي وقت Unix لاختبار الخوادم.

كيفية استخدام مولّد TOTP (المصادقة الثنائية)

  1. الصق المفتاح السري (Base32) أو انقر مفتاح عشوائي جديد.
  2. اضبط الخوارزمية وعدد الأرقام والمدة (بالثواني) لتوافق الخدمة (عادةً SHA-1 و6 و30).
  3. اقرأ الرمز الحالي والثواني المتبقية.
  4. أدخل اختياريًا وقت Unix لحساب الرمز للحظة محددة.

مثال

الإدخال
Secret GEZDGNBVGY3TQOJQGEZDGNBVGY3TQOJQ, SHA-1, 8 digits, Unix time 59
الإخراج
94287082

متجه الاختبار من الملحق B في RFC 6238 (السر هو النص ASCII ‏12345678901234567890 بصيغة Base32).

متى تستخدم مولّد TOTP (المصادقة الثنائية)

استخدمه لاختبار تنفيذ 2FA أو استرجاع الرموز على سطح المكتب حين يتوفر لديك السر أو فهم عمل TOTP. ولا تُبقِ أسرار حساباتك الحقيقية في تبويبات المتصفح؛ استخدم تطبيق مصادقة أو مدير كلمات مرور.

كيف يعمل مولّد TOTP (المصادقة الثنائية)

يحسب TOTP (RFC 6238) الدالة HOTP (RFC 4226) بالعدّاد T = floor(وقت Unix / المدة): HMAC-SHA-1/256/512 للعدّاد ذي 8 بايتات بترتيب big-endian بمفتاح هو السر بعد فك Base32، ثم الاقتطاع الديناميكي (الإزاحة = آخر نصف بايت) والباقي على 10^الأرقام. ويُحسب HMAC بواجهة Web Crypto. وتُعاد كل متجهات الاختبار في الملحق B من RFC 6238 بدقة.

حالات الاستخدام الشائعة

  • اختبار تسجيل دخول TOTP في تطبيق ويب قيد التطوير
  • فحص انحراف ساعة الخادم بمقارنة الرموز
  • إعادة إنتاج متجهات اختبار RFC 6238
  • توليد رموز لحساب اختبار في توثيق CI

ملاحظة أمنية

سر TOTP حساس مثل كلمة المرور: يستطيع كل من يملكه توليد رموزك.

الأسئلة الشائعة

لماذا لا تطابق رموزي التطبيق؟

تحقق من تطابق الخوارزمية وعدد الأرقام والمدة، ومن دقة ساعة حاسوبك؛ فاختلاف 30 ثانية في الساعة يغيّر الرمز.

هل يُرسل سري إلى أي مكان؟

لا. يُحسب HMAC في متصفحك بـ Web Crypto.

أي أبجدية Base32 تُستخدم؟

RFC 4648: الأحرف A–Z والأرقام 2–7. وتُقبل المسافات والشرطات والأحرف الصغيرة وحشو = وتُهمل.

استكشف المزيد من الفئات